package org.gcube.social_networking.rest;

import com.webcohesion.enunciate.metadata.rs.RequestHeader;
import com.webcohesion.enunciate.metadata.rs.RequestHeaders;
import com.webcohesion.enunciate.metadata.rs.ResourceGroup;
import com.webcohesion.enunciate.metadata.rs.ResourceLabel;
import org.gcube.social_networking.socialnetworking.model.shared.Notification;
import org.gcube.social_networking.socialnetworking.model.shared.Post;

import javax.ws.rs.*;

@Path("notifications")
@ResourceGroup("Notifications APIs")
@ResourceLabel("Notifications APIs")
@RequestHeaders({
        @RequestHeader( name = "Authorization", description = "Bearer token, see <a href=\"https://dev.d4science.org/how-to-access-resources\">https://dev.d4science.org/how-to-access-resources</a>")
})
public class Notifications {
    @POST
    @Path("/")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    @Consumes({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void saveNotification(Notification notification) {

    }

    @PUT
    @Path("/{id}")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void setNotificationRead(@PathParam("id") String notid) {

    }

    @GET
    @Path("/{id}")
    @Produces({"application/json;charset=UTF-8", "application/vnd.api+json"})
    public void readNotification(@PathParam("id") String notid) {

    }
}
